'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.map = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var map = function () {
  var _ref = _asyncToGenerator(_regenerator2.default.mark(function _callee2(frames) {
    var _this = this;

    var cache;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            cache = {};
            _context2.next = 3;
            return Promise.all(frames.map(function () {
              var _ref2 = _asyncToGenerator(_regenerator2.default.mark(function _callee(frame) {
                var functionName, fileName, lineNumber, columnNumber, _cache$fileName, map, fileSource, _map$originalPosition, source, line, column, originalSource;

                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        functionName = frame.functionName, fileName = frame.fileName, lineNumber = frame.lineNumber, columnNumber = frame.columnNumber;
                        _cache$fileName = cache[fileName], map = _cache$fileName.map, fileSource = _cache$fileName.fileSource;

                        if (!(map == null)) {
                          _context.next = 10;
                          break;
                        }

                        _context.next = 5;
                        return fetch(fileName).then(function (r) {
                          return r.text();
                        });

                      case 5:
                        fileSource = _context.sent;
                        _context.next = 8;
                        return (0, _stackFrameUtils.getSourceMap)(fileName, fileSource);

                      case 8:
                        map = _context.sent;

                        cache[fileName] = { map: map, fileSource: fileSource };

                      case 10:
                        _map$originalPosition = map.originalPositionFor({
                          line: lineNumber,
                          column: columnNumber
                        }), source = _map$originalPosition.source, line = _map$originalPosition.line, column = _map$originalPosition.column;
                        originalSource = map.sourceContentFor(source);
                        return _context.abrupt('return', new _stackFrame2.default(functionName, fileName, lineNumber, columnNumber, (0, _stackFrameUtils.getLinesAround)(lineNumber, 3, fileSource), functionName, source, line, column, (0, _stackFrameUtils.getLinesAround)(line, 3, originalSource)));

                      case 13:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function (_x2) {
                return _ref2.apply(this, arguments);
              };
            }()));

          case 3:
            return _context2.abrupt('return', _context2.sent);

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function map(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _stackFrame = require('stack-frame');

var _stackFrame2 = _interopRequireDefault(_stackFrame);

var _stackFrameUtils = require('stack-frame-utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.map = map;
exports.default = map;